﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using Interface;
using Log;
using System.IO;

namespace SimpleReflector
{
    class Program
    {
        static void Main(string[] args)
        {
            Program p = new Program();
            long t1=  DateTime.Now.Ticks;
            p.LoadTest1();//可以换成2查看输出时间差距
            long t2 = DateTime.Now.Ticks;
            Console.WriteLine(t2 - t1);
        }

        public void LoadTest2()
        {
            Assembly asm = Assembly.LoadFrom(@"Log.dll");
            LogInterfaceTypeAttribute logtype = (LogInterfaceTypeAttribute)
            asm.GetCustomAttributes(typeof(LogInterfaceTypeAttribute), false)[0];
            ILog log = (ILog)
            Activator.CreateInstance(asm.GetType(logtype.TypeName));
            log.WriteApplicationEvent("Initialized2...");
        }
        public void LoadTest1()
        {
            Assembly asm = Assembly.LoadFrom(@"Log.dll");
            ILog logger = null;

            foreach (Type t in asm.GetTypes())
            {
                if (t.GetInterface("ILog") != null)
                {
                    logger = (ILog)Activator.CreateInstance(t);
                    break;
                }
            }
            if (logger != null)
            {
                logger.WriteApplicationEvent("Initialized1...");
            }
        }
    }
}
